import React, { useState, useRef, useEffect } from 'react';
import { useParams } from 'react-router-dom';
import { Col, Space, Row, Tooltip } from 'antd';
import { register, aiPerson } from '@/assets/images';
import { Form, Input, Tabs, Typography, Button, Modal, Select } from '@arco-design/web-react';
import { question1, } from '@/assets/images';
import ProgressStep from '@/components/ProgressStep/VisitStep';
import SelectObjModal from '@/components/SelectObjModal/selectPerson';
import WantUserTag from '@/components/WantUserTag/Handling';
import { scan } from '@/assets/images/icon'
import DocumentScanner from '../../matterDetail/FileUpLoad';
import * as $$ from '@/utils/utility';
import CaseResult from './CaseResult'
import ArcoUpload from '@/components/ArcoUpload';
import HandleRecord from '../../matterDetail/HandleRecord';
import SupervisingView from '../../matterDetail/Supervising'
import UniteHandle from '../../matterDetail/UniteHandle';
import { useNavigate } from 'react-router-dom';


const Option = Select.Option;
const FormItem = Form.Item;
const TabPane = Tabs.TabPane;
const appUrl = $$.appUrl;



const fakeData = [
  {
    handlerUserName: '天河区棠下街综治中心',
    finishTime: new Date().getTime() - 24 * 60 * 60 * 1000, // 一天前的时间
    handleResult: '1',
    status: '2',
    taskNodeName: '来访登记',
    mediResult: '22_00025-1',
    handleContent: '调解成功，双方达成一致意见。',
    operationName: '李晓明'
  },
  {
    handlerUserName: '系统派单',
    finishTime: new Date().getTime() - 12 * 60 * 60 * 1000, // 半天前的时间
    handleResult: '1',
    status: '2',
    taskNodeName: '事件流转',
    mediResult: '22_00025-1',
    handleContent: '派单至：白云区新市街市场监管所',
  },
  {
    handlerUserName: '白云区新市街市场监管所',
    finishTime: new Date().getTime() - 11 * 60 * 60 * 1000, // 半天前的时间
    handleResult: '1',
    status: '2',
    taskNodeName: '事件流转',
    mediResult: '22_00025-1',
    handleContent: '已签收',
    operationName: '赵菲菲'
  },
  {
    handlerUserName: '白云区新市街市场监管所',
    finishTime: new Date().getTime() - 11 * 60 * 60 * 1000, // 半天前的时间
    handleResult: '1',
    status: '3',
    taskNodeName: '事件回退',
    mediResult: '22_00025-1',
    // handleContent: '已签收',
    operationName: '赵菲菲'
  },
  {
    handlerUserName: '天河区棠下街综治中心',
    finishTime: new Date().getTime() - 6 * 60 * 60 * 1000, // 6小时前的时间
    handleResult: '2',
    status: '1',
    taskNodeName: '事件流转',
    mediResult: '22_00025-1',
    handleContent: '案件已被签收，准备开始调解。',
    operationName: '李晓明'
  },
];


function choosePrincipalApi(caseId, userId) {
  return $$.ax.request({ url: `caseInfoUnfold/choosePrincipal?caseId=${caseId}&userId=` + userId, type: 'get', service: 'mediate' });
}

function delFile(id) {
  return $$.ax.request({ url: `fileInfo/deleteFileById`, type: 'delete', service: 'sys', data: { id } });
}

function getNewTimeIdApi(id) {
  return $$.ax.request({ url: `caseUtils/getNewTimeId`, type: 'get', service: 'utils' });
}

function saveFeedbackApi(data) {
  return $$.ax.request({ url: `caseFeedback/saveFeedback`, type: 'post', service: 'mediate', data });
}

function listFeedbackApi(id) {
  return $$.ax.request({ url: `caseFeedback/listFeedback?id=` + id, type: 'get', service: 'mediate' });
}

function updateFeedbackApi(data) {
  return $$.ax.request({ url: `caseFeedback/updateFeedback`, type: 'post', service: 'mediate', data });
}

function getFeedbackInfoApi(caseTaskId) {
  return $$.ax.request({ url: `caseFeedback/getFeedbackInfo?caseTaskId=` + caseTaskId, type: 'get', service: 'mediate' });
}

function getByIdRoleApi(id) {
  return $$.ax.request({ url: `ctUser/getByIdRole?id=` + id, type: 'get', service: 'cust' });
}



const Handle = ({ authorData, caseTaskId, caseId }) => {
  const formRef = useRef();
  const navigate = useNavigate();
  const [selectedTab, setSelectedTab] = useState('1'); // 默认选中第一个 tab
  const [selectedTab1, setSelectedTab1] = useState('1'); // 默认选中第一个 tab
  const [wantUser, setWantUser] = useState({});
  const [formView, setFormView] = useState(false);
  const [personView, setPersonView] = useState(false);
  const [supervising, setSupervising] = useState(false)
  const [data, setData] = useState({})
  const [feedbackInfoData, setFeedbackInfoData] = useState({})
  const [personData, setPersonData] = useState({})
  const [caseResult, SetCaseResult] = useState(false);
  const [list, setList] = useState([]);
  const [mode, SetMode] = useState(false);
  const [uniteHandleView, setUniteHandleView] = useState(false);
  const [isModalVisible, setIsModalVisible] = useState(false);
  const [id, setId] = useState('');
  const [uniteHandleId, setUniteHandleId] = useState('');
  const [caseResultId, setCaseResultId] = useState('');
  const [managerName, setManagerName] = useState('')


  const tabs = [
    { index: '1', label: '承办部门' },
    { index: '2', label: '配合部门' },
  ];

  const tabs1 = [
    { index: '1', label: '公共模板：提醒尽快启动调解程序督办模板' },
    { index: '2', label: '个人模板：推动事件尽快办结督办模板' }
  ]

  const options = [
    { value: '1', label: '一' }, { value: '2', label: '二' }, { value: '3', label: '三' }
  ];





  const handleTabChange = (newTabIndex) => {
    setSelectedTab(newTabIndex);
  };

  const handleCheckedKeys = (userId) => {
    choosePrincipal(userId)
  }

  const [scannerVisible, setScannerVisible] = useState(false);

  const handleConfirm = () => {
    // 处理确认逻辑
    setScannerVisible(false);
  };

  const handleCancel = () => {
    // 处理取消逻辑
    setScannerVisible(false);
  };

  const openScanner = () => {
    setScannerVisible(true);
  };


  const choosePrincipal = async (id) => {
    console.log(id, 'choosePrincipalId')
    const res = await choosePrincipalApi(caseId, id)
    if (res.type) {
      let data = res.data
      console.log(data, 'choosePrincipalchoosePrincipal')
    }

  }

  const getByIdRole = async () => {
    const res = await getByIdRoleApi('2105180249501982')
    setPersonData(res.data)

  }


  //删除文件
  const handleDelFile = async (id) => {
    const res = await delFile(id)
    if (res.type) {
      $$.infoSuccess({ content: '删除成功！' });
    }
  }



  //新增、编辑办理理由
  const saveFeedback = async (submitData) => {
    console.log(submitData, 'submitData1111')
    if (submitData.id) {
      //编辑
      const res = await updateFeedbackApi({
        ...submitData,
      })
      if (res.type) {
        $$.infoSuccess({ content: '修改成功' });
        listFeedback(caseId)
      }
    } else {
      const res = await saveFeedbackApi({
        ...submitData,
        caseId: caseId,
        id: id,
        caseTaskId: '',
      })
      if (res.type) {
        $$.infoSuccess({ content: '保存成功' });
        listFeedback(caseId)
      }
    }
  }

  const getFeedbackInfo = async () => {
    const res = await getFeedbackInfoApi(caseTaskId)
    setFeedbackInfoData(res.data)
    console.log(res.data, 'res.data')
  }

  //获取办理记录接口
  const listFeedback = async (id) => {
    const res = await listFeedbackApi(id)
    if (res.type) {
      let data = res.data.caseFeedbackList;
      let manager = res.data.manager
      setList(data)
      setManagerName(manager)
    }
  }

  //获取理由id
  const getNewTimeId = async (type) => {
    const res = await getNewTimeIdApi()
    if (res.type) {
      if (type === 'uniteHandle') {
        setUniteHandleId(res.data)
      }
      if (type === 'addMark')
        setId(res.data)
      if (type === 'caseResult') {
        setCaseResultId(res.data)
      }
    }
  }

  //添加办理记录
  const addMark = () => {
    setFormView(!formView);
    getNewTimeId('addMark')
  }

  //保存信息
  const handleFinish = () => {
    let submitData = formRef.current.getFields()
    saveFeedback(submitData)
    setFormView(!formView);
  }

  //点击编辑办理事由
  const handleEdit = (record) => {
    setFormView(true)
    formRef.current.setFieldsValue({
      ...record
    })
  }

  const Supervising = () => {
    setSupervising(!supervising)
  }

  const uniteHandle = () => {
    getNewTimeId('uniteHandle')
    setUniteHandleView(!uniteHandleView)
  }



  const handleTabChange1 = (newTabIndex) => {
    setSelectedTab1(newTabIndex);
  };

  const content = selectedTab1 === '1'
    ? `鉴于本事项的重要性及紧迫性，现要求你尽快启动调解程序，并确保案件能够得到及时有效的处理。请您务必于本周内完成以下事项：XX、XX、XX。请确保在事项办理的过程中，遵循公平、公正的原则，并积极促进双方达成共识`
    : '1';

  const handleSupervising = () => {
    setSupervising(!supervising)
  }

  const handlePersonView = () => {
    setPersonView(!personView)

  }

  const handleCaseResultApply = () => {
    SetCaseResult(!caseResult)
    getNewTimeId('caseResult')
  }


  useEffect(() => {
    listFeedback(caseId);
    getFeedbackInfo();
    getByIdRole();
  }, [])

  // useEffect(() => {
  //   if (authorData) {
  //     const { buttonList } = authorData;
  //     setStaticButtonList(myButton.filter(item => {
  //       const flag = buttonList.some(result => {
  //         if (result.id === item.key) {
  //           return true
  //         }
  //       })
  //       return flag
  //     }))
  //   }
  // }, [authorData])



  return (
    <>
      <div className='container'>
        <div className='container-top'>
          <Col span={24}>
            <Space size='small'>
              <div className='MediationInfo-subTitle' style={{ marginTop: '-9px' }}></div><h5>当事人信息</h5>
            </Space>
          </Col>
          <Row gutter={[16, 16]}>
            <Col span={8} style={{ display: 'flex' }}>
              <div><div className="title-text">承办部门：</div></div>
              <div>{feedbackInfoData?.handleUnitName}</div>
            </Col>
            <Col span={8} style={{ display: 'flex' }}>
              <div><div className="title-text">经办人：</div></div>
              <div style={{ display: 'flex' }}>
                <div>{feedbackInfoData?.handleUserName}</div>
                <img onClick={() => handlePersonView()} src={register} alt='' style={{ width: '14px', height: '14px', marginLeft: '8px', marginTop: '4px' }} />
              </div>
            </Col>
            <Col span={8} style={{ display: 'flex' }}>
              <div><div className="title-text">配合部门：</div></div>
              <div>{feedbackInfoData?.assistUnitName}</div>
            </Col>
            <Col span={8} style={{ display: 'flex' }}>
              <div><div className="title-text">受理时间：</div></div>
              <div>{feedbackInfoData?.acceptTime}</div>
            </Col>
          </Row>

        </div>

        <div className='container-bottom'>
          <div className='container-bottom-left'>
            <Col span={24} style={{ marginBottom: '8px' }}>
              <Space size='small'>
                <div className='MediationInfo-subTitle' style={{ marginTop: '-9px' }}></div><h5>办理反馈</h5>
              </Space>
            </Col>
            <Form
              layout='vertical'
              requiredSymbol={false}
              scrollToFirstError={true}
            >
              <Col span={8}>
                <FormItem label={<div style={{ display: 'flex' }}>
                  <span style={{ color: '#86909C' }}>经办人</span>
                  <Tooltip>
                    <img src={question1} alt="" style={{ width: '13px', height: '13px', margin: '4px 4px 0px 4px' }} />
                  </Tooltip>
                </div>
                }
                  field='level' >
                  {wantUser.wantUserId ?
                    <WantUserTag name={wantUser.wantUserName} onClose={() => setWantUser({ wantUserId: null, wantUserName: null })} />
                    :
                    caseId && managerName ?
                      <WantUserTag name={managerName} onClose={() => setWantUser({ wantUserId: null, wantUserName: null })} />
                      :
                      <Button onClick={() => setIsModalVisible(true)} style={{ color: '#1A6FB8', border: '1px solid #1A6FB8' }} type='outline'>选择</Button>
                  }
                </FormItem>
              </Col>
              <Col span={24}>
                <div style={{ color: 'rgb(134, 144, 156)' }}>办理记录</div>
                <HandleRecord isReview={false} handleEdit={handleEdit} data={list} />
                {/* {formView && */}
                <div className='Form' style={{ display: formView ? '' : 'none' }}>
                  <Col span={24} style={{ marginBottom: '8px' }}>
                    <Space size='small'>
                      <div className='MediationInfo-subTitle' style={{ marginTop: '-9px' }}></div><h5>添加办理记录</h5>
                    </Space>
                  </Col>
                  <Col span={24}>
                    <Form
                      ref={formRef}
                      layout='vertical'
                      requiredSymbol={false}
                      scrollToFirstError={true}
                    >
                      <Row gutter={[32, 0]}>
                        <Col span={24}>
                          <FormItem
                            label={<div style={{ display: 'flex' }}>
                              办理意见
                              <img src={scan} alt="" style={{ marginRight: '-2px', marginLeft: '8px' }} />
                              <div style={{ marginLeft: '8px', color: '#1A6FB8', fontSize: '14px', cursor: 'pointer' }} onClick={openScanner}>识别材料</div>
                            </div>
                            }
                            field='handleContent'
                            rules={[{ message: '请填写事项概况', required: true }]}
                          >
                            <Input.TextArea
                              maxLength={200}
                              showWordLimit
                              rows={5}
                              placeholder='请完整描述事项概况，应具备5要素：发生时间+发生地点+人物情况+事项起因+事项经过'
                              wrapperStyle={{ width: '100%' }}
                            />
                          </FormItem>

                        </Col>
                        <Col span={24}>
                          <FormItem
                            label={<div style={{ display: 'flex' }}>
                              办理附件
                            </div>
                            }
                            field='caseDes'
                            rules={[{ message: '请填写事项概况', required: true }]}
                          >
                            <ArcoUpload
                              params={{
                                action: `${appUrl.fileUrl}/${appUrl.sys}/api/web/fileInfo/upload?mainId=${caseId}&ownerId=${caseId}&ownerType=${'22_00018-501'}`,
                              }}
                              field='file1'
                              // handleChangeFile={handleChangeFile}
                              label=''
                              // editData={props.editData}
                              handleDelFile={handleDelFile}
                            />
                          </FormItem>
                        </Col>

                      </Row>
                    </Form>
                  </Col>
                  <Space size='middle'>
                    <Button type='primary' onClick={() => handleFinish()}>保存</Button>
                    <Button type='secondary' onClick={() => { setFormView(!formView); }}>取消添加</Button>
                  </Space>
                </div>
                {/* } */}
              </Col>
            </Form>
            <Space style={{ marginTop: '38px', bottom: '4px' }}>
              <Button type="primary" style={{ backgroundColor: '#1A6FB8' }} onClick={() => addMark()}>添加办理记录</Button>
              <Button type='outline' style={{ color: '#1A6FB8', border: '1px solid #1A6FB8' }} onClick={() => uniteHandle()}>联合处置申请</Button>
              <Button type='outline' style={{ color: '#1A6FB8', border: '1px solid #1A6FB8' }} onClick={() => handleCaseResultApply()} >结案申请</Button>
              <Button type='outline' style={{ color: '#EF6C24', border: '1px solid #EF6C24' }} onClick={() => Supervising()}>督办</Button>
              <Button type='secondary' onClick={() => navigate(-1)}>返回上级页面</Button>
            </Space>
          </div>
          <div className='container-bottom-right'>
            <Tabs defaultActiveTab='1' className='tabs-container' >
              <TabPane
                key='1'
                title={
                  <span style={{ fontSize: '15px' }}>
                    流转进度
                  </span>
                }
              >
                <Typography.Paragraph>
                  <div style={{ display: 'flex', marginLeft: '16px', gap: '16px' }}>
                    {tabs.map((tab) => (
                      <div
                        key={tab.index}
                        style={{
                          color: selectedTab === tab.index ? 'rgba(26,111,184,1)' : 'rgba(0,0,0,0.45)',
                          padding: '6px 12px',
                          border: `1px solid ${selectedTab === tab.index ? 'rgba(26,111,184,1)' : 'rgba(229,230,235,1)'}`,
                          borderRadius: '4px',
                          cursor: 'pointer',
                        }}
                        onClick={() => handleTabChange(tab.index)}
                      >
                        {tab.label}
                      </div>
                    ))}
                  </div>
                  {selectedTab === '1' &&
                    <div className='progress'>
                      <ProgressStep progressData={fakeData} />
                    </div>
                  }
                </Typography.Paragraph>
              </TabPane>
              <TabPane
                key='2'
                title={
                  <span style={{ fontSize: '15px' }}>
                    督办信息
                  </span>
                }
              >
                <Typography.Paragraph>
                  <SupervisingView id={id} />
                </Typography.Paragraph>
              </TabPane>
            </Tabs>

          </div>
        </div>

        {/* 选择经办人*/}
        <SelectObjModal
          visible={isModalVisible}
          checkKeys={wantUser.wantUserId ? [{ label: wantUser.wantUserName, value: wantUser.wantUserId }] : undefined}
          onOk={(value) => {
            console.log(value, 'value')
            console.log(value.key, value, 'value.key', 'value')
            setIsModalVisible(false);
            setWantUser({ wantUserId: value.keys[0], wantUserName: value.items[0].name });
            handleCheckedKeys(value.keys?.[0])
          }}
          onClose={() => setIsModalVisible(false)}
          type='person'
        />

        <DocumentScanner
          visible={scannerVisible}
          onConfirm={handleConfirm}
          onCancel={handleCancel}
        />
        <Modal visible={personView} onCancel={() => setPersonView(false)} title='工作人员信息' centered footer={null}>
          <table border="1" align="center" cellpadding="5" className="table">
            <tr>
              <th bgcolor="#F7F8FA" className="table-title" width="120">姓名</th>
              <td width='380'><div style={{ display: 'flex' }}><div>{personData?.trueName}</div></div></td>
              <th bgcolor="#F7F8FA" className="table-title" width="120">登录账号</th>
              <td width='380'>{personData?.acc}</td>
            </tr>
            <tr>
              <th bgcolor="#F7F8FA" className="table-title">手机号码</th>
              <td>{personData?.mobile}</td>
              <th bgcolor="#F7F8FA" className="table-title">工作电话</th>
              <td>-</td>
            </tr>
            <tr>
              <th bgcolor="#F7F8FA" className="table-title">所属部门</th>
              <td>{personData?.deptName}</td>
              <th bgcolor="#F7F8FA" className="table-title">职务</th>
              <td>{personData?.userRoles}</td>
            </tr>
          </table>
        </Modal>
        <Modal visible={supervising} onCancel={() => setSupervising(false)} title='督办' centered footer={null}>
          <Form
            ref={formRef}
            layout='vertical'
            requiredSymbol={false}
            scrollToFirstError={true}
            initialValues={{
              suggestion: ''
            }}//默认值
          >
            <Row>
              <Col span={24}>
                <FormItem
                  label={<div style={{ display: 'flex' }}><div>督办部门</div><div style={{ color: '#86909C' }}>（可多选）</div></div>}
                  field=''
                >
                  <Select
                    mode='multiple'
                    placeholder='请选择督办部门'
                    style={{}}
                    allowClear
                  >
                    {options.map((option) => (
                      <Option key={option.value} value={option.value} onChange={(v) => console.log(v, 'vvvvvv')}>
                        {option.label}
                      </Option>
                    ))}
                  </Select>
                </FormItem>
              </Col>
              <div style={{ marginBottom: '8px' }}>督办意见</div>
              <Col span={24}>
                <FormItem
                  field='suggestion'
                >
                  <div style={{ display: 'flex', justifyContent: 'space-between' }}>
                    <div className='tabs1'>
                      {tabs1.map((tab) => (
                        <div
                          key={tab.index}
                          style={{
                            color: selectedTab1 === tab.index ? 'rgba(26,111,184,1)' : 'rgba(0,0,0,0.45)',
                            border: `1px solid ${selectedTab1 === tab.index ? 'rgba(26,111,184,1)' : 'rgba(229,230,235,1)'}`,
                            borderRadius: '2px',
                            cursor: 'pointer',
                            padding: '0px 8px',
                          }}
                          onClick={() => handleTabChange1(tab.index)}
                        >
                          {tab.label}
                        </div>
                      ))}
                    </div>
                    <div style={{ color: '#1A6FB8' }} onClick={() => SetMode(!mode)}>更多模板</div>
                  </div>
                  <Input.TextArea
                    rows={5}
                    wrapperStyle={{ width: '700px' }}
                    value={content}
                  />
                </FormItem>
              </Col>
              <Col span={24}>
                <FormItem
                  label='附件材料'
                  field='caseDes'
                  rules={[{ message: '请填写事项概况', required: true }]}
                >
                  <ArcoUpload
                    params={{
                      action: `${appUrl.fileUrl}/${appUrl.sys}/api/web/fileInfo/upload?mainId='24083010062110001'&&ownerId=${id}&ownerType=22_00018-102`,
                    }}
                    field='file1'
                    // handleChangeFile={handleChangeFile}
                    label=''
                    // editData={props.editData}
                    handleDelFile={handleDelFile}
                  />
                </FormItem>
              </Col>
              <Button type='primary' style={{ marginTop: '-16px' }} onClick={() => handleSupervising()}>提交</Button>
            </Row>
          </Form>
        </Modal>
        <UniteHandle id={uniteHandleId} visible={uniteHandleView} handleOnCancel={() => setUniteHandleView(false)} />
        <CaseResult visible={caseResult} handleOnCancel={() => SetCaseResult(false)} caseResultId={caseResultId} caseId={caseId} caseTaskId={caseTaskId} />

      </div>
    </>
  )

}

export default Handle;